routes/web.php
<?php

use App\Http\Controllers\web\LanguageController;
use App\Http\Controllers\web\ContactController;
use App\Http\Controllers\web\DarkThemeController;
use App\Http\Controllers\web\CommentController;
use App\Http\Controllers\web\OrderController;
use App\Http\Controllers\web\ProductController;
use App\Http\Controllers\web\UserController;
use Illuminate\Support\Facades\Route;
use \App\Http\Controllers\web\CategoryController;
use \App\Http\Controllers\web\CartController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('welcome');
//});
Route::view('/', 'static_sites.start')->name('start_view');
Route::post('/contact', ContactController::class)->name('web.contact_form');
Route::view('/contact', 'static_sites.contact')->name('contact_view');

Route::redirect('products/comments', '/products/comments/start');
Route::resource('products', ProductController::class, ['as' => 'web', 'except' => '']);
//Route::resource('products', ProductController::class);
Route::resource('products.comments', CommentController::class, ['as' => 'web', ]);
Route::get('products/comments/start', [CommentController::class, 'start'])->name('web.products.start');
Route::get('products/{slug}', [ProductController::class, 'show'])->name('web.products.show');

Route::group([
    // 'prefix' => 'pl', //  do geta
    'as' => 'web.',
    'middleware' => [
        // 'verified',
        // 'auth',
        // 'userLogs'
    ],
    ], function() {
        Route::get('categories/', [CategoryController::class, 'index'])->name('categories.index');
        // Route::get('categories/{category}', [CategoryController::class, 'show'])->name('categories.show');
        Route::get('categories/{slug}', [CategoryController::class, 'show'])->name('categories.show');

        // Route::get('users', [UserController::class, 'index'])->name('users.index');
        // Route::get('users/{user}', [UserController::class, 'edit'])->name('users.edit');
        // Route::delete('users/{user}', [UserController::class, 'destroy'])->name('user.delete');
        Route::resource('users', UserController::class)->only(['index', 'edit', 'update', 'destroy']);

        Route::get('cart/index', [CartController::class, 'index'])->name('cart.index');
        Route::post('cart/{product}/{goBackWithMessage?}', [CartController::class, 'store'])->name('cart.store');
        Route::delete('cart/{product}', [CartController::class, 'destroy'])->name('cart.destroy');

        Route::get('orders', [OrderController::class, 'index'])->name('orders.index');
        Route::post('orders', [OrderController::class, 'store'])->name('orders.store');
        Route::get('orders/{order}', [OrderController::class, 'show'])->name('orders.show');
    }
);

Route::get('/dark-theme', DarkThemeController::class)->name('web.dark_theme');
Route::get('lang/{lang}', [LanguageController::class, 'switchLang'])->name('web.lang_switch');

app/Models/Comment.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Comment extends Model
{
    use HasFactory;

    protected $fillable = ['name', 'email', 'content'];

}

app/Models/Product.php
<?php declare(strict_types=1);

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Product extends Model
{
    use HasFactory;

    protected $fillable = ['name', 'slug', 'description', 'price'];

    public function comments() : HasMany
    {
        return $this->hasMany(Comment::class);
    }

    /**
     * @TODO Refactor zaprogramuj życie - kategorie
     */
    //    public function isSelectedCategory(int $category_id): bool
    //    {
    //        return $this->hasCategory() && $this->category->id = $category_id;
    //    }

    //    public function hasCategory()
    //    {
    //        return !is_null($this->category);
    //    }

    public function category() : BelongsTo
    {
        return $this->belongsTo(Category::class);
    }

    public function orders(): BelongsToMany
    {
        return $this->belongsToMany(Order::class);
    }
}

app/Http/Controllers/api/v1/ProductController.php
<?php declare(strict_types=1);

namespace App\Http\Controllers\api\v1;

use App\Http\Controllers\Controller;
use App\Http\Requests\ProductPostRequest;
use App\Http\Resources\ProductResource;
use App\Models\Product;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Symfony\Component\HttpFoundation\Response as SymfonyResponse;

/**
 * https://laravel.com/docs/8.x/controllers
 */
class ProductController extends Controller
{

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return ProductResource::collection(Product::all());
        return Product::paginate(4);
        return \DB::table('products')->paginate(3);
        return Product::all();
    }

    public function pagination(int $perPage = 10)
    {
        $list = Product::paginate($perPage);
        return response()->json($list, 200);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create() : Response
    {
        die;
    }

    /**
     * Store a newly created resource in storage.
     * POSTMAN:
     * Headers: application/json
     * Body: form-data
     * Body: name: Product Two
     * Body: slug: product-two
     *
     * @param  \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(ProductPostRequest $request)
    {
        // return Product::create($request->all());
        $product = Product::create($request->validated());
        return new ProductResource($product);
    }

    public function show(Product $product) : ProductResource
    {
        return new ProductResource($product);
        // return $product;
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id) : Response
    {
        die;
    }

    public function update(ProductPostRequest $request, int $id) : Response
    {
        $validated = $request->validated();
        $product = Product::findOrFail($id);
    }

    public function destroy(int $id) : SymfonyResponse
    {
        $product = Product::findOrFail($id); // 500
        // $product = Product::find($id); // 500
        $product->delete();

        // HTTP Status 204 (No Content) - RESTful API
        return response(null, SymfonyResponse::HTTP_NO_CONTENT);
        return response(null, 204);
    }
}

app/Http/Controllers/web/CommentController.php
<?php declare(strict_types=1);

namespace App\Http\Controllers\web;

use App\Http\Controllers\Controller;
use App\Http\Requests\CommentStoreRequest;
use App\Http\Requests\CommentUpsertRequest;
use App\Models\Comment;
use App\Models\Product;
use Illuminate\Http\Request;
use Illuminate\View\View;

class CommentController extends Controller
{
    public function start(): View
    {
        $products = Product::all('name', 'slug');
        return view('products.comments.start', compact('products'));
    }

    public function index(Request $request): View
    {
        $products = Product::all('name', 'slug');
        $product = Product::where('slug', $request->product)
            ->with('comments')
            ->firstOrFail();
        return view('products.comments.index', compact('product', 'products'));
    }

    public function create(Request $request): View
    {
        $product = Product::where('slug', $request->product)->first();
        $products = Product::all('name', 'slug');
        return view('products.comments.create', compact('products', 'product'));
    }

    public function show(Request $request): View
    {
        $products = Product::all('name', 'slug');
        $product = Product::where('slug', $request->product)
            ->with('comments')
            ->firstOrFail();
        $comment = Comment::findOrFail($request->comment);
        return view('products.comments.show', compact('product', 'products', 'comment'));
    }

    public function store(CommentStoreRequest $request, Product $product)
    {
        $validated = $request->validated();
        $validated['product_id'] =$product->id;
        $product_id = $product->id;
        dd($validated);
        Comment::created($validated);
    }

    public function edit(Product $product, Comment $comment): View
    {
        return view('products.comments.edit', compact('comment', 'product'));
    }

    public function update(CommentUpsertRequest $request, $id)
    {
        $comment = Comment::findOrFail($id);
        $comment->update($request->validated());
        return redirect()->back()->with('success', __('crud.actions.update'));
    }

    public function destroy(Product $product, Comment $comment)
    {
        $comment->delete();
        return redirect()->back()->with('success', __('crud.actions.delete'));
        // return redirect()->back()->with('success', 'Element usunięto');
    }

    public function destroyAndRedirectToIndex(Product $product, Comment $comment)
    {
        $comment->delete();
        return redirect()->route('web.products.index')->with('success', 'Element usunięto');
    }
}

app/Http/Controllers/web/ProductController.php
<?php

namespace App\Http\Controllers\web;

use App\Http\Controllers\Controller;
use App\Http\Requests\ProductPostRequest;
use App\Http\Requests\ProductUpdateRequest;
use App\Models\Comment;
use App\Models\Product;
use App\Repositories\ProductRepository;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\View\View;

class ProductController extends Controller
{
    private ProductRepository $productRepository;

    /**
     * @TODO  wstrzykiwać interfejs
     * np.:
     * https://www.twilio.com/blog/repository-pattern-in-laravel-application
     * @param ProductRepository $productRepository
     */
    public function __construct(ProductRepository $productRepository)
    {
        $this->productRepository = $productRepository;
    }

    public function index(): View
    {
        $products = Product::paginate(9);
        // $products =  $this->productRepository->getAll();
        // $products = Product::all();
        return view('products.index', compact('products'));
    }

    public function create(): View
    {
        return view('products.create');
    }

    public function store(ProductPostRequest $request) : View
    {
        $product = Product::create($request->validated());
        return view('products.show', compact('product'))->with('success', 'Success');;
    }

    public function show(string $slug) : View
    {
        $product = Product::with(['comments', 'category'])
            ->where('slug', $slug)
            ->firstOrFail();
         return view('products.show', compact('product', ));
    }

    public function edit(string $slug): View
    {
        $product = Product::where('slug', $slug)->firstOrFail();
        return view('products.edit', compact('product'));
    }

    public function update(ProductUpdateRequest $request, $id)
    {
        $product = Product::findOrFail($id);
        $product->update($request->validated());
        return redirect()
            ->route('products.show', ['slug' => $request->validated()['slug']])
            ->with('success', 'Product updated');
    }

    public function destroy(Product $product): RedirectResponse
    {
        $product->delete();
        return redirect()->route('web.products.index')->with('success', 'Product deleted!');
    }
}

resources/views/products/comments/comment.blade.php
<div class="bg-light p-4 mb-3 border">
    <div class="d-flex justify-content-between small text-muted mb-1">
        <p>{{ $comment->name }} | <a href="mailto:{{ $comment->email }}">{{ $comment->email }}</a> </p>
        <p>{{ $comment->created_at }}</p>
    </div>
    <p class="lead">Lorem ipsum dolor sit amet, consectetur adipisicing elit. Debitis, facilis.</p>
    <div class="my-2 text-end">
        <form class="d-inline-block" action="{{ route('web.products.comments.destroy', ['product' => $product->id, 'comment' => $comment->id]) }}" method="POST">
            @csrf
            @method('DELETE')
            <input type="submit" class="btn btn-sm btn-dark" value="Delete Comment">
        </form>
        <a href="{{ route('web.products.comments.edit', ['product' => $product->id, 'comment' => $comment->id]) }}" class="btn btn-sm btn-outline-dark">Edit Comment</a>
    </div>
</div>

resources/views/products/comments/create.blade.php
@extends('layout.my_monolit')

@section('title', 'Products')

@section('main')

    @include('products.module_elements.header')

    <div class="card pt-5 mb-4">
        <div class="card-body">
    <article>
        <div class="text-center mb-5">
            <h1 class="display-1">{{ $product->name }}</h1>
            <h3 class="display-6 ">Add a comment:</h3>
        </div>
        @include('layout.my_monolit.site_elements.form_errors')
        <form action="{{ route('web.products.comments.store', ['product' => $product->id]) }}" method="POST">
            @csrf
            @method('POST')
            @include('products.comments.form')
            <input type="submit" class="btn btn-outline-dark" value="Add">
        </form>
    </article>
        </div>
    </div>
@endsection

resources/views/products/comments/edit.blade.php
@extends('layout.my_monolit')

@section('main')
    @include('layout.my_monolit.site_elements.flash_message')
    <div class="card  pt-5 mb-4">
        <div class="card-body">
            <h1 class="display-1 text-center mb-4">Edit a comment</h1>
            <form action="{{ route('web.products.comments.update', ['product' => $product->id, 'comment' => $comment->id]),  }}" method="POST">
                @csrf
                @method('PUT')
                @include('products.comments.form')
                <input type="submit" value="Update" class="btn btn-secondary">
            </form>
            <div class="mt-4">
                @include('layout.my_monolit.site_elements.btn_form_delete', ['action' => route('web.products.comments.destroy', ['product' => $product, 'comment' => $comment]), 'description' => 'Delete comment', 'form_class' => 'd-inline'])
                @include('layout.my_monolit.site_elements.link_btn_dark', ['href' => url()->previous(), 'text' => 'Back'])
                @include('layout.my_monolit.site_elements.link_btn_dark', ['href' =>route('web.products.index'), 'text' => 'All products'])
            </div>
        </div>
    </div>
@endsection

resources/views/products/comments/form.blade.php
<div class="row g-3 mb-2">
    <div class="col">
        <input type="text" name="name" class="form-control mb-0 @error('name') is-invalid @enderror" placeholder="Name" aria-label="Name" value="{{ $comment->name ?? old('name') ?? '' }}">
        <div id="nameHelp" class="form-text mt-0 text-muted">* Required, max 32 chars.</div>
        @error('name')
        <div class="alert alert-danger small mt-1">{{ $message }}</div>
        @enderror
    </div>
    <div class="col">
        <input type="text" name="comment-email" class="form-control @error('comment-email') is-invalid @enderror" placeholder="Email" aria-label="Email" value="{{ $comment->email ?? old('comment-email') ?? '' }}">
        <div id="emailHelp" class="form-text small mt-0 text-muted">* Required, max 32 chars.</div>
        @error('comment-email')
        <div class="alert alert-danger small mt-1">{{ $message }}</div>
        @enderror
    </div>
</div>
<div class="mb-2">
    <textarea name="comment-content" class="form-control @error('comments-content') is-invalid @enderror" rows="3" placeholder="Your Comment">{{ $comment->content ?? old('comments-content') ?? '' }}</textarea>
    <div id="contentHelp" class="form-text mt-0 text-muted">* Required</div>
    @error('comments-content')
    <div class="alert alert-danger small mt-1">{{ $message }}</div>
    @enderror
</div>

resources/views/products/comments/index.blade.php
@extends('layout.my_monolit')

@section('title', 'Products')

@section('main')
    @include('layout.my_monolit.site_elements.flash_message')
<section id="products">
    @include('products.module_elements.header')
    <div class="card pt-5 mb-4">
        <div class="card-body">
            <div class="mb-5 text-center">
                <h1 class="display-1">{{ $product->name }}</h1>
                <a href="{{ route('web.products.comments.create', ['product' => $product->slug]) }}" class="mt-3 btn btn-outline-dark rounded-0">Add a comment</a>
            </div>

            <div class="row px-2">
                <table class="table table-striped table-sm">
                    <thead>
                    <tr>
                        <th scope="col">#</th>
                        <th scope="col">ID</th>
                        <th scope="col">Text</th>
                        <th scope="col">Author</th>
                        <th scope="col">Email</th>
                        <th scope="col">Created at</th>
                        <th scope="col">Actions</th>
                    </tr>
                    </thead>
                    <tbody class="small">
                        @forelse($product->comments as $comment)
                            <tr>
                                <th scope="row">{{ $loop->iteration }}</th>
                                <td>{{ $comment->id }}</td>
                                <td>{{ Str::limit($comment->content, 20) }}</td>
                                <td>{{ $comment->name }}</td>
                                <td>{{ $comment->email }}</td>
                                <td>{{ $comment->created_at }}</td>
                                <td>
                                    <a href="{{ route('web.products.comments.edit', ['product' => $product->id, 'comment' => $comment->id]) }}" title="edit comment" class="btn btn-sm btn-outline-primary rounded-0"><i class="far fa-edit"></i></a>
                                    <a href="{{ route('web.products.comments.show', ['product' => $product->slug, 'comment' => $comment->id]) }}" title="show comment" class="btn btn-sm btn-outline-success rounded-0"><i class="far fa-arrow-alt-circle-right"></i></a>
                                    <form class="d-inline-block" action="{{ route('web.products.comments.destroy', ['product' => $product->id, 'comment' => $comment->id]) }}" method="POST">
                                        @csrf
                                        @method('DELETE')
                                        <button type="submit" class="btn btn-sm btn-outline-danger rounded-0"><i class="far fa-trash-alt"></i></button>
                                    </form>
                                </td>

                            </tr>
                        @empty
                            <p>No comments yet!</p>
                        @endforelse

                    </tbody>
                </table>
            </div>

            <div class="my-3">
{{--                {{ $product->$commenlinks() }}--}}
            </div>
        </div>
    </div>
</section>
@endsection

resources/views/products/comments/show.blade.php
@extends('layout.my_monolit')

@section('title', 'Products')

@section('main')

    @include('products.module_elements.header')
    @include('products.module_elements.product_card')
    <div class="bg-light p-4 mb-3 border">
    <div class="d-flex justify-content-between small text-muted mb-1">
        <p>{{ $comment->name }} | <a href="mailto:{{ $comment->email }}">{{ $comment->email }}</a> </p>
        <p>{{ $comment->created_at }}</p>
    </div>
    <p class="lead">Lorem ipsum dolor sit amet, consectetur adipisicing elit. Debitis, facilis.</p>
    <div class="my-2 text-end">
        <form class="d-inline-block" action="{{ route('web.products.comments.destroy', ['product' => $product->id, 'comment' => $comment->id]) }}" method="POST">
            @csrf
            @method('DELETE')
            <input type="submit" class="btn btn-sm btn-dark" value="Delete Comment">
        </form>
        <a href="{{ route('web.products.comments.edit', ['product' => $product->id, 'comment' => $comment->id]) }}" class="btn btn-sm btn-outline-dark">Edit Comment</a>
    </div>
</div>
@endsection

resources/views/products/comments/start.blade.php
@extends('layout.my_monolit')

@section('title', 'Products')

@section('main')
    @include('layout.my_monolit.site_elements.flash_message')
    <section id="products">
        @include('products.module_elements.header')
    </section>
@endsection